#------------------------------------------------------------------------
# -*- mode: cmake -*-
#
# NOTE:
#   Must be called after including CPack
#------------------------------------------------------------------------
include(CMakeParseArguments)
function(ax_project NAME VERSION)
  #----------------------------------------------------------------------
  # Handle argument parsing
  #----------------------------------------------------------------------
  set( options
       PRIMARY
  )
  set( oneValueArgs
       URL
       SPEC_FILENAME
       PORTFILE
  )
  set( multiValueArgs
  )
  cmake_parse_arguments(ARG "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN} )
  #----------------------------------------------------------------------
  # Break down the version number
  #----------------------------------------------------------------------
  string( REGEX REPLACE
  	  "^([0-9]+)([.].+|)" "\\1"
	  VERSION_MAJOR
	  "${VERSION}" )
  string( REGEX REPLACE
	  "^[0-9]+[.]([0-9]+)([.].+|)" "\\1"
	  VERSION_MINOR
	  "${VERSION}" )
  string( REGEX REPLACE
	  "^[0-9]+[.][0-9]+[.]([0-9]+)([.].+|)" "\\1"
	  VERSION_PATCH
	  "${VERSION}" )
  string( REGEX REPLACE
	  "^[0-9]+[.][0-9]+[.][0-9]+[.][0-9]+[.]([0-9]+)([.].+|)" "\\1"
	  VERSION_TWEEK
	  "${VERSION}" )
  #----------------------------------------------------------------------
  # 
  #----------------------------------------------------------------------
  if ( NOT ARG_SPEC_FILENAME )
    set(ARG_SPEC_FILENAME "${CMAKE_CURRENT_BINARY_DIR}/${NAME}.spec")
  endif ( NOT ARG_SPEC_FILENAME )
  if ( NOT ARG_PORTFILE )
    set(ARG_PORTFILE "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Portfile.in")
  endif ( NOT ARG_PORTFILE )
  if ( NOT ARG_URL )
    set( ARG_URL " " )
  endif ( NOT ARG_URL )
  #----------------------------------------------------------------------
  # Set variables
  #----------------------------------------------------------------------
  set( ${NAME}_URL ${ARG_URL} CACHE INTERNAL "" )
  set( ${NAME}_VERSION ${VERSION} CACHE INTERNAL "" )
  set( ${NAME}_VERSION_MAJOR ${VERSION_MAJOR} CACHE INTERNAL "" )
  set( ${NAME}_VERSION_MINOR ${VERSION_MINOR} CACHE INTERNAL "" )
  set( ${NAME}_VERSION_PATCH ${VERSION_PATCH} CACHE INTERNAL "" )
  set( ${NAME}_VERSION_TWEEK ${VERSION_TWEEK} CACHE INTERNAL "" )
  set( ${NAME}_SPEC_FILENAME ${ARG_SPEC_FILENAME} CACHE INTERNAL "" )
  set( ${NAME}_PORTFILE ${ARG_PORTFILE} CACHE INTERNAL "" )
  if ( ARG_PRIMARY )
    set( PROJECT_URL           ${${NAME}_URL}           CACHE INTERNAL "" )
    set( PROJECT_VERSION       ${${NAME}_VERSION}       CACHE INTERNAL "" )
    set( PROJECT_VERSION_MAJOR ${${NAME}_VERSION_MAJOR} CACHE INTERNAL "" )
    set( PROJECT_VERSION_MINOR ${${NAME}_VERSION}_MINOR CACHE INTERNAL "" )
    set( PROJECT_VERSION_PATCH ${${NAME}_VERSION_PATCH} CACHE INTERNAL "" )
    set( PROJECT_VERSION_TWEEK ${${NAME}_VERSION_TWEEK} CACHE INTERNAL "" )
    set( PROJECT_SPEC_FILENAME ${${NAME}_SPEC_FILENAME} CACHE INTERNAL "" )
    set( PROJECT_PORTFILE      ${${NAME}_PORTFILE}      CACHE INTERNAL "" )
  endif ( ARG_PRIMARY )
endfunction(ax_project)
