{//------------------- test macro for the buttherworth filter
gROOT->Reset();  

FrFile *ifile;
FrvRFFT *fft;
TH1F *histo0, *histo1, *histo2, *histo3, *histo4, *histo5, *histo6;
int nData, iVect, i;
double dt, phase = 0;

nData = 2000;
dt = 1./nData;
vect = FrVectNew1D("InputNoise",FR_VECT_8R, nData,dt,"time [s]","Volts");

fftIn = FrvRFFTNew("HAP0", 0, 0);
fftHP = FrvRFFTNew("HAP0", 0, 0);
fftLP = FrvRFFTNew("HAP0", 0, 0);
fftPB = FrvRFFTNew("HAP0", 0, 0);

filterHP = FrvFilterButNew(6, 100., 0., "6th order high pass filter at 100Hz");
filterLP = FrvFilterButNew(8,   0., 400, "8th order low pass filter at 400Hz");
filterPB = FrvFilterButNew(9, 100., 200, "9th order pass band filter [100-200Hz]");

for(iVect = 0; iVect<10; iVect++) {//----------- we loop on many vectors--

  for(i=0; i<nData; i++) { //--generate some noise signal with a line-----
    phase+= 6.2831853*157.*dt;
    vect->dataD[i] = gRandom->Gaus() + sin(phase);}

   FrvFilterButProc(filterHP, vect);
   FrvFilterButProc(filterLP, vect);
   FrvFilterButProc(filterPB, vect);

   FrvRFFTFor(fftIn, vect);
   FrvRFFTFor(fftHP, filterHP->output);
   FrvRFFTFor(fftLP, filterLP->output);
   FrvRFFTFor(fftPB, filterPB->output);}

//-----------plots
   
can = new TCanvas("can","RUN",800,600);

gPad->SetLogx();
gPad->SetLogy();
gPad->SetGrid();

 histo1 = FrVP(fftIn->amplitudeA, "DRAW", 1);
 histo1->SetMinimum(.00001);
 histo1->SetMaximum(1);
 histo1->GetXaxis()->SetRangeUser(5,1.e10);
 histo1->SetTitle();
 FrVP(fftHP->amplitudeA, "SAME", 2);
 FrVP(fftLP->amplitudeA, "SAME", 4);
 FrVP(fftPB->amplitudeA, "SAME", 6);

}
